<template>
  <div class="dashboard-page-container pb-5">
    <h1 class="page-title">Profile</h1>
    <div class="mt-4">
      <div class="row">
        <div class="col-sm-12 col-md-6">
          <div class="card card-setting">
            <form @submit.prevent="submitForm" class="form-container">
              <div class="py-5 px-2">
                <div class="form-group">
                  <div class="form-input my-5">
                    <label class="text-primary"> Profile Image </label>
                    <FormulateForm v-model="formValues">
                      <FormulateInput
                        type="image"
                        name="profileImage"
                        label=""
                        help="Select a png, jpg or gif to upload."
                        validation="required|mime:image/jpeg,image/png,image/gif"
                      />
                    </FormulateForm>
                  </div>
                  <div class="form-input mb-3">
                    <label for="formFirstName">First Name</label>
                    <input
                      type="text"
                      class="form-control"
                      id="formFirstName"
                      placeholder="FirstName"
                      v-model="form.firstName"
                      v-validate="'required'"
                      name="First Name"
                      disabled
                    />
                    <div
                      v-show="verrors.has('First Name')"
                      class="invalid-feedback"
                    >
                      {{ verrors.first('First Name') }}
                    </div>
                  </div>
                </div>
                <div class="form-group my-3">
                  <div class="form-input mb-3">
                    <label for="formLastName">Last Name</label>
                    <input
                      type="text"
                      class="form-control"
                      id="formLastName"
                      placeholder="FirstName"
                      v-model="form.surname"
                      v-validate="'required'"
                      name="Last Name"
                      disabled
                    />
                    <div
                      v-show="verrors.has('Last Name')"
                      class="invalid-feedback"
                    >
                      {{ verrors.first('Last Name') }}
                    </div>
                  </div>
                </div>
                <div class="form-group my-3">
                  <div class="form-input mb-3">
                    <label for="formEmail">Email</label>
                    <input
                      type="text"
                      class="form-control"
                      id="formEmail"
                      placeholder="Email"
                      v-model="form.email"
                      v-validate="'required'"
                      name="Email"
                      disabled
                    />
                    <div v-show="verrors.has('Email')" class="invalid-feedback">
                      {{ verrors.first('Email') }}
                    </div>
                  </div>
                </div>
                <div class="form-group my-3">
                  <div class="form-input mb-3">
                    <label for="formPhoneNumber">Phone Number</label>
                    <input
                      type="text"
                      class="form-control"
                      id="formPhoneNumber"
                      placeholder="Phone Number"
                      v-model="form.phoneNumber"
                      v-validate="'required'"
                      name="Phone Number"
                      disabled
                    />
                    <div
                      v-show="verrors.has('Phone Number')"
                      class="invalid-feedback"
                    >
                      {{ verrors.first('Phone Number') }}
                    </div>
                  </div>
                </div>
                <div class="form-group my-3">
                  <div class="form-input mb-3">
                    <label for="formDOB">Date of Birth</label>
                    <input
                      type="text"
                      class="form-control"
                      id="formDOB"
                      placeholder="DOB"
                      :value="formatDate(form.dateOfBirth)"
                      v-validate="'required'"
                      name="DOB"
                      disabled
                    />
                    <div v-show="verrors.has('DOB')" class="invalid-feedback">
                      {{ verrors.first('DOB') }}
                    </div>
                  </div>
                </div>
                <div class="mt-5">
                  <p class="text-primary text-center">
                    You can only edit your profile picture
                  </p>
                  <vs-button
                    type="submit"
                    :loading="form.active"
                    primary
                    class="px-5 py-1 w-100"
                  >
                    Save Details
                  </vs-button>
                </div>
              </div>
            </form>
          </div>
        </div>
      </div>
    </div>
    <!-- Modal -->
    <!-- Successful Modal -->
    <div
      class="modal fade"
      id="PaymentSuccessModal"
      tabindex="-1"
      data-bs-backdrop="static"
    >
      <div class="modal-dialog modal-dialog-centered">
        <div
          class="modal-content d-flex justify-content-center align-items-center"
        >
          <div class="modal-body py-5">
            <div class="text-center">
              <img src="@/assets/images/transfer-success-icon.png" />
            </div>
            <div class="px-5 text-center mt-3">
              <h3 class="fw-bold text-dark my-2">
                Profile Updated Successful!
              </h3>

              <p class="text-muted my-2 px-3">Your Profile has been updated.</p>

              <div class="mt-3">
                <div class="d-flex justify-content-center">
                  <button
                    class="btn btn-primary btn-lg rounded-1 px-5 h6"
                    type="button"
                    data-bs-dismiss="modal"
                    style="font-size: 14px"
                  >
                    <span class="px-2"> OK </span>
                  </button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
// import TransferBetweenAccounts from '@/assets/icons/transfer-between-accounts.svg?inline'
// import TransferToCorebankAccount from '@/assets/icons/transfer-to-corebank-account.svg?inline'
// import TransferToOtherBanks from '@/assets/icons/transfer-to-other-banks.svg?inline'

export default {
  layout: 'dashboard',
  components: {},
  data: () => ({
    formValues: {},
    form: {
      active: false,
    },
  }),

  computed: {
    user() {
      return this.$store.getters['auth/user']
    },
  },
  created() {
    this.form = {
      ...this.form,
      ...this.user,
    }
  },
  methods: {
    openNotification(position = null, color, message) {
      this.$vs.notification({
        progress: 'auto',
        color,
        position,
        title: message,
        text: '',
      })
    },
    formatDate(value) {
      if (!value) return

      return new Date(value).toDateString()
    },
    submitForm() {
      this.$validator.validateAll().then((result) => {
        if (result) {
          const data = {
            profileImage: this.formValues.profileImage.files[0].previewData,
          }
          this.form.active = true

          this.$axios
            .patch('/user/profile', data)
            .then(({ data }) => {
              console.log(data)
              this.form.active = false
              // eslint-disable-next-line
              const modal = new bootstrap.Modal(
                document.getElementById('PaymentSuccessModal'),
                {}
              )
              modal.show()
              this.openNotification('top-left', 'success', data.message)
              this.$store.commit('auth/UPDATE_USER_DATA', data.payload)
            })
            .catch((error) => {
              // console.log(error)
              this.form.active = false
              if (
                error.response.status === 404 ||
                error.response.status === 400 ||
                error.response.status === 401 ||
                error.response.status === 403 ||
                error.response.status === 406 ||
                error.response.status === 409
              ) {
                // console.log(error.response.data.message)
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              } else {
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              }
            })
        }
      })
    },
  },
}
</script>

<style lang="scss">
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';

.text-sm {
  font-size: 12px;
}

.dashboard-page-container {
  .choose-transfer-type-card,
  .fill-beneficiary-details {
    background: #ffffff;
    border-radius: 20px;

    input.form-control,
    .form-select,
    textarea.form-control {
      background-color: #f4f2ec;
      border-radius: 5px;
      border: none;
    }
  }
  .card-setting .nav-link {
    border: none;
    color: #000;
    font-weight: bold;
    background: none;
    border-radius: 0;
    margin: 0 5px;
    &.active {
      border-bottom: 3px solid $primary;
      color: #000;
      font-weight: bold;
      background: none;
      border-radius: 0;
    }
  }
  .form-container {
    // margin-top: -20vh;
    min-height: auto;
    // width: 65%;
    // @include media-breakpoint-down(sm) {
    //   position: relative;
    //   width: 100%;
    // }
    .form-input {
      input,
      select {
        border: none;
        background: transparent;
        border-radius: 0;
        border-bottom: 1px solid $dark;
        padding: 15px 0;

        min-width: 52px;

        box-shadow: none;
        &:focus {
          box-shadow: none;
          border-bottom: 1px solid $primary;
        }
      }
    }
  }
}
</style>
